#include <stdio.h>
#include <pthread.h>
#include <assert.h>
#include <stdlib.h>

static pthread_key_t  oTLSKey;

static void myCPLCleanupTLSList( void * )
{
    printf("myCPLCleanupTLSList\n");
}

static __attribute__((destructor)) void shared_object_finish() {
    printf(">shared_object_finish\n");
    if( !getenv("NO_KEY_DELETE") ) 
        pthread_key_delete(oTLSKey);
    printf("<shared_object_finish\n");
}


extern "C" void do_work() {
    printf(">do_work\n");
    assert( pthread_key_create( &oTLSKey , (void (*)(void*)) myCPLCleanupTLSList ) == 0 );
    assert( pthread_setspecific( oTLSKey, (void**)1 ) == 0 );
    /* pthread_setspecific( oTLSKey, NULL ); */
    printf("<do_work\n");
}
